/*
 * Copyright (c) 2004 by Tsuyoshi Iguchi (zinnia@risky-safety.org)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: flip_fader.c,v 1.3 2004/05/18 03:49:36 zinnia Exp $
 */
#include "sps.h"
static gboolean Process(SPS_Flip_Parameter* param)
{
	double alpha;
	const int ms = 1000;
	SPS_Draw_Parameter dparam;

	alpha = (double)(param->tick_current - param->tick_begin) / (double)ms;
	if(alpha > 1.0) alpha = 1.0;

	dparam.alpha = 1.0 - alpha;
	SPS_Scene_Draw_Generic(param->scene_before, SPS_DRAW_PARAMETER_ENUM_ALPHA, &dparam, TRUE);
	dparam.alpha = alpha;
	SPS_Scene_Draw_Generic(param->scene_after, SPS_DRAW_PARAMETER_ENUM_ALPHA, &dparam, TRUE);

	if(alpha == 1.0) return FALSE;
	return TRUE;
}

SPS_Flip_Vector fader_vector = {
	TRUE, // require_opengl
	"CrossFader", // name
	"Simple cross fader.", // description
	TRUE, // disappear
	TRUE, // appear
	Process,
};

	
