/*
 * Copyright (c) 2004 by Tsuyoshi Iguchi (zinnia@risky-safety.org)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: misc.h,v 1.4 2004/05/18 03:12:20 zinnia Exp $
 */

#ifndef __MISC_H
#define __MISC_H
#include "sps.h"

extern void usage();

extern TTF_Font* GetFont(SPS_Render_Context* context, const char* fontindex);
extern SPS_Sprite* GetIcon(SPS_Render_Context* context, const char* iconindex);
extern void SDL_UnMapRGB(SDL_PixelFormat* fmt, SDL_Color* dst, Uint32 color);
extern gchar* get_utf8_string(const char* str);


extern int TTF_Style_Parse(const char* expression);
extern int RatioToPixelH(SPS_Render_Context* context, double h);
extern int RatioToPixelV(SPS_Render_Context* context, double v);
extern int RatioToPixel(SPS_Render_Context* context, double l);
extern Uint32 ParseColor(SPS_Render_Context* context, const char* text);

extern void setup_opengl();
extern void SDL_GL_Enter2DMode(gboolean origin_center);
extern void SDL_GL_Leave2DMode();

extern GList* ReadLines(const char* path);
#endif
